#include <stdio.h>       /* standard stuff */
#include "../mgui/include/mgui.h"
#include "../pandora/pan_glob.h"
#if !defined UNIX
 #include <sys/builtin.h> /* for simple semaphore stuff for WIN */
 #include <sys/smutex.h>  /* for simple semaphore stuff for WIN */
#else
 #include <pthread.h>     /* semaphore & threading for Unix */
#endif

/*
 * Global Variables
 * Accessible by all programs, due to declaration in pangui.h
 * pangui.h beeing systematically included in the header of all modules
 *
 * The makefile is were links are resolved : when the main shell (this program)
 * calls a function within one of the modules
 *
 */

/* Main Form variables */
MOBJECT main_shell; /* the main shell */
MOBJECT form0;      /* password shell form */
MOBJECT form1;      /* result shell form */
MOBJECT edit_00;    /* selected target edit field */

 /* Menu forms */
MOBJECT slist;       /* list in the password shell form */
MOBJECT rlist;       /* list in the result shell form */
MOBJECT mouse_menu;

#if !defined UNIX
 _smutex attacking;        /* Crack action */
#else
 pthread_mutex_t attacking;
#endif

 /* default colors */
MTColor black, white, darkblue, cadetblue, seagreen;
long    NColors;

 /* Pandora file variables */
Pan_PassHack pPassHack; /* Current password record being hacked */
Pan_PassList pPassList; /* Memory dump of the password list */
Pan_PassList *Index; /* Index of the above list for sorting facility */
Pan_NDSBrowse pNDSBrowse; /* Memory dump of NDS ACL's */
Pan_NDSBrowse *Index2;
Pan_Connections pConnections; /* Memory dump of current connections */
Pan_Connections *Index3;
long int nIndex; /* Number of items in the list */

/** temporary vars that contains current path and file extension **/
char ret_path[MAXPATHLEN+MAXFNAMELEN];
char ext[MAXFNAMELEN];

/* Default Cracking Preferences */
struct
  {
   uint32 try_before_save;
   short dict_attack_type; /* 1 is selected object, 2 range of objects */
   short speed; /*TRUE for fast display, FALSE for detailed display (slow)*/
   char key_space[PAN_KEYSPACE+1]; /* self defined key space */
   char ini_path[MAXPATHLEN];
   char save_path[MAXPATHLEN];
   char save_file[MAXPATHLEN+MAXFNAMELEN];
   char default_server[MAXNAMELEN];
   int  async_trick;
  }preference;

/* path in which the prog is launched */
char start_path[MAXPATHLEN];
